#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <graphics.h>
#include <dos.h>
#include <string.h>

#define VERTICES 30
#define ARISTAS 60
#define MAXCOLOR 4
#define MAXXI VERTICES
#define MAXYI VERTICES
#define MAXXFNC VERTICES*MAXCOLOR+1
#define MAXYFNC VERTICES*2+ARISTAS*MAXCOLOR

struct datos{
	int x;
	int y;
	int color;
	struct datos *ant;
	};

struct datos1{
       int x1;
       int y1;
       int x2;
       int y2;
       struct datos1 *ant;
       };

char matriz_adyacencia[MAXYI][MAXXI],nnodos=0;
char vreduce[MAXYFNC],noincid=0;
char matriz_FNC[MAXYFNC][MAXXFNC];


void LlenaMatrizFNC();
void reduce(char matriz_FNC[MAXYFNC][MAXXFNC],char vreduce[MAXXFNC]);
char *davisputnam(char matriz_FNC[MAXYFNC][MAXXFNC],char vred[MAXXFNC]);
void sustituye(int TF,int x,char matriz_FNC[MAXYFNC][MAXXFNC]);
void Interfaz();


struct datos *recorre,*elemento,*ultimo;
struct datos1 *recorre1,*elemento1,*ultimo1;

void limpia()
{ int x,y;
  for(y=0;y<MAXYI;y++)
    for(x=0;x<MAXXI;x++)
       matriz_adyacencia[y][x]=0;
}


int initializemouse()
{ union REGS iReg, oReg;
  iReg.x.ax=0;
  int86(0x33,&iReg,&oReg);
  if (oReg.x.ax==0xFFFF)
     return oReg.x.bx;
  else
     return 0;
}

void showmousepointer()
{ union REGS iReg, oReg;
  iReg.x.ax=1;
  int86(0x33,&iReg,&oReg);
}

void getmouseposition(int *x,int *y, int *button)
{ union REGS iReg, oReg;

  iReg.x.ax=3;
  int86(0x33,&iReg,&oReg);
  *x=oReg.x.cx;
  *y=oReg.x.dx;
  *button=oReg.x.bx;
}

void hidemousepointer()
{ union REGS iReg,oReg;
  iReg.x.ax=2;
  int86(0x33,&iReg,&oReg);
}


void Initialize(void)
{
  int xasp, yasp;			/* Used to read the aspect ratio*/
  int GraphDriver,GraphMode,ErrorCode;

  GraphDriver = DETECT; 		/* Request auto-detection	*/
  initgraph( &GraphDriver, &GraphMode, "" );
  ErrorCode = graphresult();		/* Read result of initialization*/
  if( ErrorCode != grOk ){		/* Error occured during init	*/
    printf(" Graphics System Error: %s\n", grapherrormsg( ErrorCode ) );
    exit( 1 );
  }
}

int esta_cerca(int x1,int y1,int x2,int y2)
{
   if (((x2<x1+40)&&(x2>x1-40))&&((y2<y1+40)&&(y2>y1-40)))
      return 1;
   else
      return 0;
}

void push(int x,int y,int color)
{
  elemento=(struct datos *)malloc(sizeof(struct datos));
  elemento->x=x;
  elemento->y=y;
  elemento->color=color;

  if(ultimo==NULL)
   { ultimo=elemento;
     ultimo->ant=NULL;
   }
   else
   { recorre=ultimo;
     ultimo=elemento;
     elemento->ant=recorre;
   }
}

void push1(int x1,int y1,int x2,int y2)
{
  elemento1=(struct datos1 *)malloc(sizeof(struct datos1));
  elemento1->x1=x1;
  elemento1->y1=y1;
  elemento1->x2=x2;
  elemento1->y2=y2;

  if(ultimo1==NULL)
   { ultimo1=elemento1;
     ultimo1->ant=NULL;
   }
   else
   { recorre1=ultimo1;
     ultimo1=elemento1;
     elemento1->ant=recorre1;
   }
}

void elimina()
{ int x,y;

  while(ultimo)
  { recorre=ultimo->ant;
    free(ultimo);
    ultimo=recorre;
  }

  while(ultimo1)
  { recorre1=ultimo1->ant;
    free(ultimo1);
    ultimo1=recorre1;
  }

  for(y=0;y<MAXYI;y++)
     for(x=0;x<MAXXI;x++)
	matriz_adyacencia[y][x]=0;

  for(y=0;y<MAXYFNC;y++)
     for(x=0;x<MAXXFNC;x++)
	matriz_FNC[y][x]=0;

  for(x=0;x<MAXXFNC;x++)
      vreduce[x]=0;

  nnodos=0;
  noincid=0;

}

void pop()
{ char *p;
  int no_nodos=nnodos;

  recorre=ultimo;
  while(recorre)
	{
	 setcolor(0);
	 if (recorre->color!=-1)
	  {  setfillstyle(1,recorre->color);
	     fillellipse(recorre->x,recorre->y,17,17);
	  }
	  else { circle(recorre->x,recorre->y,17);}
	 itoa((long)no_nodos--,p,10);
	 outtextxy((recorre->x)-7,(recorre->y)-5,p);
	 recorre=recorre->ant;
	}
}

void pop1()
{ recorre1=ultimo1;
  while(recorre1)
	{
	 setcolor(0);
	 line(recorre1->x1,recorre1->y1,recorre1->x2,recorre1->y2);
	 recorre1=recorre1->ant;
	}
}

void encuentra_adyacencia(int x1,int y1,int x2,int y2)
{ int no_nodo=nnodos-1,nodo1=0,nodo2=0;

  recorre=ultimo;
  while((recorre)&&(!nodo1))
	{
	 if (esta_cerca(recorre->x,recorre->y,x1,y1))
	    nodo1=no_nodo;
	 recorre=recorre->ant;
	 no_nodo--;
	}
  no_nodo=nnodos-1;
  recorre=ultimo;
  while((recorre)&&(!nodo2))
	{
	 if (esta_cerca(recorre->x,recorre->y,x2,y2))
	    nodo2=no_nodo;
	 recorre=recorre->ant;
	 no_nodo--;
	}

  if ((nodo1!=0)&&(nodo2!=0))
    { if (nodo1!=nodo2)
	 if (nodo1<nodo2) matriz_adyacencia[nodo1][nodo2]=1;
	    else matriz_adyacencia[nodo2][nodo1]=1;
    }
  else
   { if ((nodo1==0)&&(nodo2!=0)) { matriz_adyacencia[nodo1][nodo2]=1; }
     if ((nodo1!=0)&&(nodo2==0)) { matriz_adyacencia[nodo2][nodo1]=1; }
   }

}


char *davisputnam(char mFNC[MAXYFNC][MAXXFNC],char vred[MAXXFNC])
{ int celiminadas=0,cvacia=0,salida=0,y,x,c=0;

    c=0; reduce(mFNC,vred);
    for(y=0;y<(noincid*MAXCOLOR)+(nnodos*2);y++)
       if (mFNC[y][0]==0) celiminadas++;
    if (celiminadas==((noincid*MAXCOLOR)+(nnodos*2))) return vred;
       else
	 { for(y=0;( (y<(noincid*MAXCOLOR)+(nnodos*2)) && (salida!=1));y++)
	     { for(x=1;((x<(nnodos*MAXCOLOR)+1)&&(salida!=1));x++)
		  if (mFNC[y][x]>=0) cvacia++;
	       if ((cvacia==0)&&(mFNC[y][0]==1)) { salida=1; cvacia=1;  }
		  else cvacia=0;
	     }

	  if (cvacia==1)
	       { vred[0]=-1; return vred;}
	       else { salida=0;
		      for(y=0;( (y<(noincid*MAXCOLOR)+(nnodos*2)) && (salida!=1));y++)
			 for(x=1;((x<(nnodos*MAXCOLOR)+1)&&(salida!=1));x++)
			   if (mFNC[y][0]==1)
			      if (mFNC[y][x]>=0) { c=x; salida=1; }

		 sustituye(1,c,mFNC);
		 vred=davisputnam(mFNC,vred);
		 if (vred[0]!=-1) vreduce[c-1]=1;

		 return vred;
		 }
	 }
}


void sustituye(int TF,int x,char mFNC[MAXYFNC][MAXXFNC])
{ int y;

   for(y=0;y<(noincid*MAXCOLOR)+(nnodos*2);y++)
   {
     if (mFNC[y][0]==1)
      { if (((mFNC[y][x]==1)&&(TF==1))||((mFNC[y][x]==0)&&(TF==0)))
	   mFNC[y][0]=0;
	else
	if (((mFNC[y][x]==1)&&(TF==0))||((mFNC[y][x]==0)&&(TF==1)))
	   mFNC[y][x]=-2;

      }
   }
}

void reduce(char mFNC[MAXYFNC][MAXXFNC],char vred[MAXXFNC])
{ int NC,x,y,nclaus,c=0;

   NC=(noincid*MAXCOLOR)+(nnodos*2);


   for (y=0; y< NC; y++)
   {
      if (mFNC[y][0]==1)
      { nclaus=0;
	for (x=1; x<(nnodos*MAXCOLOR)+1;x++)
	    if (mFNC[y][x] >= 0) { c=x; nclaus++; }

	if (nclaus==1)
	{ if (mFNC[y][c]==1)
	   { sustituye(1,c,mFNC);
	     vred[c-1]=1;
	   } else
	   { sustituye(0,c,mFNC);
	     vred[c-1]=0;
	   }
	}
      }

    }
}


void LlenaMatrizFNC()
{ int y,x,c,b,z;

  //Rellenamos con -1 la Matriz_FNC

  for(y=0;y<((noincid*MAXCOLOR)+(nnodos*2));y++)
   { for(x=1;x<(nnodos*MAXCOLOR)+1;x++)
	matriz_FNC[y][x]=-1;
     matriz_FNC[y][0]=1;
   }

  //Primero y Segundo grupo de clausulas

  c=1;
  for(y=0;y<nnodos;y++)
   { for(x=c;x<MAXCOLOR+c;x++)
       { matriz_FNC[y][x]=1;
	 matriz_FNC[y+nnodos][x]=0;
       }
     c+=MAXCOLOR;
   }

  //Tercer grupo de clausulas

  b=2*nnodos;
  for(y=0;y<nnodos;y++)
   for(x=0;x<nnodos;x++)
     if (matriz_adyacencia[y][x]==1)
       { for(z=b,c=1;z<b+MAXCOLOR;z++,c++)
	  { matriz_FNC[z][(y*MAXCOLOR)+c]=0;
	    matriz_FNC[z][(x*MAXCOLOR)+c]=0;
	  }
	 b+=MAXCOLOR;
       }
}


void ObtenFNC()
{ int y,x;

  limpia();
  recorre1=ultimo1;
  while(recorre1)
  { encuentra_adyacencia(recorre1->x1,recorre1->y1,recorre1->x2,recorre1->y2);
    recorre1=recorre1->ant;
  }

  /* Matriz FNC */

  // Contamos el numero de incidencias
  noincid=0;
  for(y=0;y<nnodos;y++)
   for(x=0;x<nnodos;x++)
     if (matriz_adyacencia[y][x]==1) noincid++;

  LlenaMatrizFNC();

}

void pintaAT(int xs,int ys,int xi,int yi)
{
  setfillstyle(1,15);
  bar(xs,ys,xi,yi);
}

void activa_DP()
{ int y,x,b,z,r;
  char *p="\0";
  int ver[30];
  int no_nodos=nnodos;

  ObtenFNC();

  for(x=0;x<(nnodos*MAXCOLOR);x++) vreduce[x]=1;
  davisputnam(matriz_FNC,vreduce);

  for(x=0,z=1;x<(nnodos*MAXCOLOR);x+=4,z++)
     for(y=x,r=1;r<5;y++,r++)
	if (vreduce[y]==1)
	   ver[z-1]=r;

    // Dibuja grafo coloreado

     pintaAT(1,27,639,348);
     hidemousepointer();
       recorre=ultimo;
       while(recorre)
	{
	 setfillstyle(1,ver[no_nodos-1]);
	 fillellipse(recorre->x,recorre->y,17,17);
	 recorre->color=ver[no_nodos-1];
	 itoa((long)no_nodos--,p,10);
	 outtextxy((recorre->x)-7,(recorre->y)-5,p);
	 recorre=recorre->ant;
	}
	pop1();pop();
    showmousepointer();

}

void pintaboton(int xs,int ys,int xi,int yi,int interruptor)
{ int a,b;

  setfillstyle(1,7);
  if (interruptor==0) { a=15; b=8; }
     else {a=8; b=15;}

  bar(xs,ys,xi,yi);
  setcolor(a);
  line(xs,ys,xs,yi);
  line(xs,ys,xi,ys);
  setcolor(b);
  line(xi,ys+1,xi,yi-1);
  line(xi,yi,xs+1,yi);
}

void pintabarra(int xs,int ys,int xi,int yi)
{
  setfillstyle(1,7);
  bar(xs,ys,xi,yi);
  setcolor(15);
  rectangle(xs,ys,xi,yi);
  setcolor(8);
  line(xs+1,ys+1,xs+1,yi-1);
  line(xs+1,ys+1,xi-1,ys+1);
  setcolor(15);
  line(xi,ys+1,xi,yi-1);
  line(xi,yi,xs+1,yi);
}

void Interfaz()
{
 initializemouse();
 Initialize();
 pintabarra(1,350,639,479);
 pintabarra(1,1,639,25);
 pintabarra(30,380,609,449);

 pintaboton(125,410,50,440,0);
 outtextxy(67 ,400, "Borrar" );

 pintaboton(200,410,125,440,0);
 outtextxy(150 ,400, "Nodo" );
 pintaboton(275,410,200,440,0);
 outtextxy(215 ,400, "Arista" );
 pintaboton(350,410,275,440,0);
 outtextxy(285 ,400, "Colorea" );
 pintaboton(425,410,350,440,0);
 outtextxy(360 ,400, "Refresh" );
 pintaboton(500,410,425,440,0);
 outtextxy(450 ,400, "FNC" );
 pintaboton(575,410,500,440,0);
 outtextxy(515 ,400, "Salir" );

 pintaAT(1,27,639,348);
 outtextxy(50,10,"Sistema Coloreador de Grafos              ITESM campus Cuernavaca" );
 outtextxy(235,365,"Opciones del Sistema" );
 showmousepointer();
}

void FNC()
{ char *p;
  int y,x;

  setcolor(3);
      for(y=0;y<((noincid*MAXCOLOR)+(nnodos*2));y++)
	 for(x=0;x<(nnodos*MAXCOLOR)+1;x++)
	    { if (matriz_FNC[y][x]!=-1)
		 { itoa((long)matriz_FNC[y][x],p,10);
		   strcat(p,"\0"); outtextxy(x*8,y*8,p);strcpy(p,"\0");
		 } else
		 { strcpy(p," \0"); outtextxy(x*8,y*8,p); }
	    }

  getch();
}


int pon_vertices()
{ int x,y,button,salida=0;
  int x1,y1,button1,paso=0;
  char *p;

  for(;salida==0;)
   {
     getmouseposition(&x,&y,&button);
     if (((x>=200)||(x<=125))||((y>=440)||(y<=410)))
     { if ((button==1)&&((x!=x1)&&(y!=y1)))
       {
	 if (((x>1)&&(x<639))&&((y>27)&&(y<328)))
	 {
	  setcolor(0);
	  hidemousepointer();
	  circle(x,y,17);
	  itoa((long)nnodos+1,p,10);
	  outtextxy(x-7,y-5,p);
	  nnodos++;
	  showmousepointer();
	  push(x,y,-1);
	  x1=x;y1=y;
	  delay(200);
	 }
       }
       paso=1;
     }
     else
     if ((button==1)&&(paso==1))
      {
	hidemousepointer();
	pintaboton(200,410,125,440,0);
	showmousepointer();
	salida=1;
	delay(200);
      }
   }
   return salida;
}

int pon_aristas()
{ int x,y,button,salida=0,p=0;
  int x1=0,y1=0,button1,paso=0;

  for(;salida==0;)
   {
     getmouseposition(&x,&y,&button);

     if ((x1>0)&&(y1>0))
     {
       if (((x>1)&&(x<639))&&((y>27)&&(y<328)))
       {
	 if (((x1>1)&&(x1<639))&&((y1>27)&&(y1<328)))
	 {
	  setcolor(0);
	  line(x1,y1,x,y);
	  setcolor(15);
	  line(x1,y1,x,y);
	 }
	 else
	 {  setcolor(0);
	    line(x1,328,x,y);
	    setcolor(15);
	    line(x1,328,x,y);
	 }

       } else
       {
	 if (((x1>1)&&(x1<639))&&((y1>27)&&(y1<328)))
	 {
	  setcolor(0);
	  line(x1,y1,x,328);
	  setcolor(15);
	  line(x1,y1,x,328);
	 } else
	 { setcolor(0);
	  line(x1,328,x,328);
	  setcolor(15);
	  line(x1,328,x,328);
	 }
       }

     }

     if (((x>=275)||(x<=200))||((y>=440)||(y<=410)))
     { if (button==1)
       { if (((x>1)&&(x<639))&&((y>27)&&(y<328)))
	 {
	  if (p<2)
	  { if ((x!=x1)&&(y!=y1))
	     {
	       p++; setcolor(0);
	       putpixel(x,y,17);
	       if (p==2)
	       { setcolor(0);
		 hidemousepointer();
		 line(x1,y1,x,y);
		 showmousepointer();
		 push1(x1,y1,x,y);
		 x1=0;y1=0,p=0;
		 salida=1;
		 hidemousepointer();
		 pintaboton(275,410,200,440,0);
		 showmousepointer();
		 delay(300);
	      }
	       x1=x;y1=y;
	     }
	  }
	  paso=1;
	}
       }
     else
     if ((button==1)&&(paso==1))
      { hidemousepointer();
	pintaboton(275,410,200,440,0);
	showmousepointer();
	salida=1;
      }
    }
   }
   return salida;
}

void Proceso()
{  int x,y,button=0,salida=0,termine=0;

   for(;salida==0;)
   { getmouseposition(&x,&y,&button);
     if (button==1)
	if ((((x<200)&&(x>125))&&((y<440)&&(y>410)))&&(termine==0))
	   { hidemousepointer();
	     pintaboton(200,410,125,440,1);
	     showmousepointer();
	     pon_vertices();
	   } else
	     if ((((x<275)&&(x>200))&&((y<440)&&(y>410)))&&(termine==0))
	     { hidemousepointer();
	       pintaboton(275,410,200,440,1);
	       showmousepointer();
	       pon_aristas();
	     }else
	     if ((((x<350)&&(x>275))&&((y<440)&&(y>410)))&&(termine==0))
	     { pintaboton(350,410,275,440,1);
	       activa_DP();
	       outtextxy(220,340,"Presione Borrar o Salir ");
	       pintaboton(350,410,275,440,0);
	       termine=1;
	     }else
	     if (((x<425)&&(x>350))&&((y<440)&&(y>410))&&(termine==0))
	     {
	       hidemousepointer();
	       pintaboton(425,410,350,440,1);
	       pintaAT(1,27,639,348);
	       pop1();pop();
	       pintaboton(425,410,350,440,0);
	       showmousepointer();

	     }else
	     if (((x<500)&&(x>425))&&((y<440)&&(y>410))&&(termine==0))
	     { pintaboton(500,410,425,440,1);
	       cleardevice();
	       ObtenFNC();
	       FNC();
	       Interfaz(); pop();pop1();
	     } else
	     if (((x<125)&&(x>50))&&((y<440)&&(y>410)))
	     { pintaboton(125,410,50,440,1);
	       elimina();
	       pintaAT(1,27,639,348);
	       pintaboton(125,410,50,440,0);
	       termine=0;
	     }else
	     if (((x<575)&&(x>500))&&((y<440)&&(y>410)))
	     { pintaboton(575,410,500,440,1);
	       salida=1;
	     }
   }
}

void main()
{
 Interfaz();
 Proceso();

}


